pcl::BoundaryEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

BoundaryEstimation estimates whether a set of points is lying on surface boundaries using an angle criterion. More...

`#include <pcl/features/boundary.h>`

Inheritance diagram for pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >:

## Public Types

typedef boost::shared_ptr< BoundaryEstimation< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const BoundaryEstimation< PointInT, PointNT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| BoundaryEstimation ()
| Empty constructor. More...
bool | isBoundaryPoint (const pcl::PointCloud< PointInT > &cloud, int q_idx, const std::vector< int > &indices, const Eigen::Vector4f &u, const Eigen::Vector4f &v, const float angle_threshold)
| Check whether a point is a boundary point in a planar patch of projected points given by indices. More...
bool | isBoundaryPoint (const pcl::PointCloud< PointInT > &cloud, const PointInT &q_point, const std::vector< int > &indices, const Eigen::Vector4f &u, const Eigen::Vector4f &v, const float angle_threshold)
| Check whether a point is a boundary point in a planar patch of projected points given by indices. More...
void | setAngleThreshold (float angle)
| Set the decision boundary (angle threshold) that marks points as boundary or regular. More...
float | getAngleThreshold ()
| Get the decision boundary (angle threshold) as set by the user. More...
void | getCoordinateSystemOnPlane (const PointNT &p_coeff, Eigen::Vector4f &u, Eigen::Vector4f &v)
| Get a u-v-n coordinate system that lies on a plane defined by its normal. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Estimate whether a set of points is lying on surface boundaries using an angle criterion for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

float | angle_threshold_
| The decision boundary (angle threshold) that marks points as boundary or regular. More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT>
class pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >

BoundaryEstimation estimates whether a set of points is lying on surface boundaries using an angle criterion.

The code makes use of the estimated surface normals at each point in the input dataset.

Here's an example for estimating boundary points for a PointXYZ point cloud:

pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>);
// fill in the cloud data here
pcl::PointCloud<pcl::Normal>::Ptr normals (new pcl::PointCloud<pcl::Normal>);
// estimate normals and fill in \a normals
pcl::PointCloud<pcl::Boundary> boundaries;
pcl::BoundaryEstimation<pcl::PointXYZ, pcl::Normal, pcl::Boundary> est;
est.setInputCloud (cloud);
est.setInputNormals (normals);
est.setRadiusSearch (0.02); // 2cm radius
est.setSearchMethod (typename pcl::search::KdTree<PointXYZ>::Ptr (new pcl::search::KdTree<PointXYZ>)
est.compute (boundaries);

Attention
  The convention for Boundary features is:
  - if a query point's nearest neighbors cannot be estimated, the boundary feature will be set to NaN (not a number)
  - it is impossible to estimate a boundary property for a point that doesn't have finite 3D coordinates. Therefore, any point that contains NaN data on x, y, or z, will have its boundary feature property set to NaN.

Author
  Radu B. Rusu

Definition at line 81 of file boundary.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef boost::shared_ptr<const BoundaryEstimation<PointInT, PointNT, PointOutT> > pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 85 of file boundary.h.

## PointCloudOut

template<typename PointInT, typename PointNT, typename PointOutT>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::PointCloudOut

Definition at line 98 of file boundary.h.

## Ptr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef boost::shared_ptr<BoundaryEstimation<PointInT, PointNT, PointOutT> > pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::Ptr

Definition at line 84 of file boundary.h.

## Constructor & Destructor Documentation

## BoundaryEstimation()

template<typename PointInT, typename PointNT, typename PointOutT>

pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::BoundaryEstimation | ( |  | ) |

inline

Empty constructor.

The angular threshold angle_threshold_ is set to M_PI / 2.0

Definition at line 104 of file boundary.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, and pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::isBoundaryPoint().

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Estimate whether a set of points is lying on surface boundaries using an angle criterion for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset that contains boundary point estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 117 of file boundary.hpp.

References pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::getCoordinateSystemOnPlane().

## getAngleThreshold()

template<typename PointInT, typename PointNT, typename PointOutT>

float pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::getAngleThreshold | ( |  | ) |

inline

Get the decision boundary (angle threshold) as set by the user.

Definition at line 150 of file boundary.h.

References pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::angle_threshold_.

## getCoordinateSystemOnPlane()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::getCoordinateSystemOnPlane | ( | const PointNT & | p_coeff,
|  | Eigen::Vector4f & | u,
|  | Eigen::Vector4f & | v
| ) |  |

inline

Get a u-v-n coordinate system that lies on a plane defined by its normal.

Parameters

  [in] | p_coeff | the plane coefficients (containing the plane normal)
  [out] | u | the resultant u direction
  [out] | v | the resultant v direction

Definition at line 161 of file boundary.h.

References pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::computeFeature().

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints().

## isBoundaryPoint() [1/2]

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::isBoundaryPoint | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | int | q_idx,
|  | const std::vector< int > & | indices,
|  | const Eigen::Vector4f & | u,
|  | const Eigen::Vector4f & | v,
|  | const float | angle_threshold
| ) |  |

Check whether a point is a boundary point in a planar patch of projected points given by indices.

Note
  A coordinate system u-v-n must be computed a-priori using getCoordinateSystemOnPlane

Parameters

  [in] | cloud | a pointer to the input point cloud
  [in] | q_idx | the index of the query point in cloud
  [in] | indices | the estimated point neighbors of the query point
  [in] | u | the u direction
  [in] | v | the v direction
  [in] | angle_threshold | the threshold angle (default )

Definition at line 49 of file boundary.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::BoundaryEstimation(), and pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints().

## isBoundaryPoint() [2/2]

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::isBoundaryPoint | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const PointInT & | q_point,
|  | const std::vector< int > & | indices,
|  | const Eigen::Vector4f & | u,
|  | const Eigen::Vector4f & | v,
|  | const float | angle_threshold
| ) |  |

Check whether a point is a boundary point in a planar patch of projected points given by indices.

Note
  A coordinate system u-v-n must be computed a-priori using getCoordinateSystemOnPlane

Parameters

  [in] | cloud | a pointer to the input point cloud
  [in] | q_point | a pointer to the querry point
  [in] | indices | the estimated point neighbors of the query point
  [in] | u | the u direction
  [in] | v | the v direction
  [in] | angle_threshold | the threshold angle (default )

Definition at line 60 of file boundary.hpp.

References pcl::PointCloud< PointT >::points.

## setAngleThreshold()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::setAngleThreshold | ( | float | angle | ) |

inline

Set the decision boundary (angle threshold) that marks points as boundary or regular.

(default )

Parameters

  [in] | angle | the angle threshold

Definition at line 143 of file boundary.h.

References pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::angle_threshold_.

## Member Data Documentation

## angle_threshold_

template<typename PointInT, typename PointNT, typename PointOutT>

float pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::angle_threshold_

protected

The decision boundary (angle threshold) that marks points as boundary or regular.

(default )

Definition at line 179 of file boundary.h.

Referenced by pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::getAngleThreshold(), and pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::setAngleThreshold().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/boundary.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/boundary.hpp